## gtk+3.0 3.24.24

=== meson_options.txt ===
# GDK backends
option('x11_backend', type: 'boolean', value: true,
  description : 'Enable the X11 gdk backend (only when building on Unix)')
option('wayland_backend', type: 'boolean', value: true,
  description : 'Enable the wayland gdk backend (only when building on Unix except for macOS)')
option('broadway_backend', type: 'boolean', value: false,
  description : 'Enable the broadway (HTML5) gdk backend')
option('win32_backend', type: 'boolean', value: true,
  description : 'Enable the Windows gdk backend (only when building on Windows)')
option('quartz_backend', type: 'boolean', value: true,
  description : 'Enable the macOS gdk backend (only when building on macOS)')

# Optional dependencies
option('xinerama', type: 'combo', choices : ['yes', 'no', 'auto'], value : 'auto',
  description : 'Enable support for the Xinerama extension')
option('cloudproviders', type: 'boolean', value: false,
  description : 'Enable the cloudproviders support')
option('profiler', type: 'boolean', value: false,
  description : 'Enable profiler support')
option('tracker3', type: 'boolean', value: false,
  description : 'Enable Tracker3 filechooser search')

# Print backends
option('print_backends', type : 'string', value : 'auto',
  description : 'Build the specified print backends (comma-separated list, any of "cloudprint,cups,file,lpr,papi,test" or "auto")')
option('colord', type: 'combo', choices : ['yes', 'no', 'auto'], value : 'auto',
  description : 'Build colord support for the CUPS printing backend')

# Documentation and introspection
option('gtk_doc', type: 'boolean', value: 'false',
  description : 'Build API reference with gtk-doc')
option('man', type: 'boolean', value: 'false',
  description : 'Build man pages for installed tools')
option('introspection', type: 'boolean', value: 'true',
  description : 'Build introspection data (requires gobject-introspection)')

# Demos and binaries
option('demos', type: 'boolean', value: 'true',
  description : 'Build demo programs')
option('examples', type: 'boolean', value: 'true',
  description : 'Build examples')
option('tests', type: 'boolean', value: 'true',
  description : 'Build tests')
option('installed_tests', type: 'boolean', value: 'false',
  description : 'enable installed tests')

# input modules
option('builtin_immodules', type: 'combo', choices : ['yes', 'no', 'auto'],
       value: 'auto', description: 'Build immodules into GTK so/DLL')

=== debian/changelog ===
gtk+3.0 (3.24.24-4+deb11u4) bullseye; urgency=medium

  * d/p/Stop-looking-for-modules-in-cwd.patch:
    Add patch backported from 3.24.43 to avoid looking for modules in
    current working directory (CVE-2024-6655)

 -- Simon McVittie <smcv@debian.org>  Fri, 19 Jul 2024 14:30:18 +0100

gtk+3.0 (3.24.24-4+deb11u3) bullseye; urgency=medium

  * d/p/gdk_wayland_display_init_gl-use-GLES-API-if-required.patch:
    Apply patch from 3.24.35 to fix Wayland + EGL on GLES-only platforms.
    Previously, GTK assumed that EGL could use the OpenGL API everywhere,
    but some proprietary drivers like those for Raspberry Pi and Vivante
    only support OpenGL ES. Allow use of OpenGL ES to be forced via
    environment variable GDK_GL=gles.
    Thanks to Dominique Martinet (Closes: #1020937)

 -- Simon McVittie <smcv@debian.org>  Fri, 24 Feb 2023 19:07:01 +0000

gtk+3.0 (3.24.24-4+deb11u2) bullseye; urgency=medium

  [ Jian-Hong Pan ]
  * d/p/printing-Create-temporary-queues-for-Avahi-printers.patch,
    d/p/printing-Show-all-Avahi-advertised-printers.patch:
    Backport patches from upstream 3.24.25 to enable temporary CUPS queues
    for local printers advertised via mDNS.
    This enables GTK to discover local printers and print to them, without
    needing to install the cups-browsed package or configure CUPS queues
    manually.
    (Closes: #982925)
  * d/p/Don-t-try-to-create-local-cups-printers-before-CUPS-2.2.patch:
    Backport patch from upstream 3.24.29 to make the printing module
    identical to the more widely-tested version in unstable.

  [ Simon McVittie ]
  * debian/cups-Use-the-same-name-mangling-as-Debian-11-s-cups-brows.patch:
    Avoid creating confusing duplicate printer entries if the printer's mDNS
    name begins or ends with a non-alphanumeric character. This change is
    specific to the Debian 11 version of cups-browsed, and is not necessary
    with cups-browsed 1.28.11 or later.
  * d/p/wayland-Ensure-clipboard-handling-doesn-t-lock-up-in-cert.patch:
    Backport patch from upstream 3.24.31 to prevent Wayland clipboard
    handling from locking up in certain corner cases (Closes: #1006281)

 -- Simon McVittie <smcv@debian.org>  Thu, 10 Mar 2022 10:30:09 +0000

gtk+3.0 (3.24.24-4+deb11u1) bullseye; urgency=medium

  * Add patch from upstream to fix missing search results when using NFS
    (Closes: #976334)
  * d/gbp.conf, d/control.in: Set packaging branch to debian/bullseye

 -- Simon McVittie <smcv@debian.org>  Sun, 13 Feb 2022 13:27:26 +0000

gtk+3.0 (3.24.24-4) unstable; urgency=medium

  * Add various patches from upstream 3.24.25 to 3.24.29, mostly
    crash fixes:
    - d/p/gdkpixbuf-drawable-Free-the-pixbuf-on-Cairo-error.patch:
      Fix a memory leak when a Cairo error occurs
    - d/p/Wayland-ignore-touch-tablet-events-on-destroyed-surfaces.patch:
      Fix crashes if input events are received on a recently-closed window
      or menu
    - d/p/label-Skip-updating-link-state-if-we-have-no-layout.patch:
      Fix crash if a GtkLabel's activate-link handler changes the
      label's markup
    - d/p/x11-dnd-Ignore-XErrors-from-the-COW.patch:
      Adds a missing error trap to prevent crashes in X11 drag & drop.
      The X11 functions called here cannot normally fail, but it seems
      they can fail in certain configurations of the NVIDIA proprietary
      driver. (LP: #1911036)
    - d/p/cssshadowvalue-Apply-device-scale-to-the-offset-when-blur.patch:
      Apply scale factor to blurred shadows.
      In particular this makes the desktop-icons-ng GNOME Shell extension,
      as used in Ubuntu 21.04, display correctly on HiDPI displays.
      (LP: #1919404)
    - d/p/scale-Fix-sporadic-criticals.patch:
      Fix a possible crash due to use-after-free
    - d/p/fontchooser-Fix-some-since-annotations.patch:
      Correct documentation
    - d/p/x11-Be-quiet-on-exit-by-default.patch:
      Don't spam the system log when disconnected from the X11 display
    - d/p/Fix-a-possible-crash-in-gtk_show_uri.patch:
      Don't crash if asked to display a URI that doesn't have a useful
      basename
    - d/p/x11-Don-t-beep-on-untrusted-displays.patch:
      Don't beep if connected to an X11 display that distrusts the
      application (ssh -X -oForwardX11Trusted=no), which can result in a
      fatal error
    - d/p/placesview-Open-location-even-if-mount-was-not-found.patch:
      Fix inability to display SMB server's list of shares
      (e.g. smb://192.168.1.1/) in Nautilus
  * d/p/updateiconcache-Sort-list-of-entries.patch:
    Mark as applied upstream to GTK 3 as well as to GTK 4

 -- Simon McVittie <smcv@debian.org>  Sun, 02 May 2021 12:34:12 +0100

gtk+3.0 (3.24.24-3) unstable; urgency=medium

  * d/patches: Backport font settings bug fixes recommended by upstream

 -- Simon McVittie <smcv@debian.org>  Mon, 22 Feb 2021 17:51:13 +0000

gtk+3.0 (3.24.24-2) unstable; urgency=medium

  * d/watch: Cope with "+" being escaped to "%2B" in links to tarballs
  * Increase dependency on librsvg2-common from Suggests to Recommends.
    This is not a hard dependency, but should be installed in nearly all
    cases. Increasingly many icons are provided in SVG format, so
    applications will appear broken if the SVG pixbuf loader is not
    installed. See #980396 for more information.
    adwaita-icon-theme already Recommends librsvg2-common, but people who
    routinely do not install recommended packages will get a better hint
    about how much will be broken by its removal if GTK also recommends it.

 -- Simon McVittie <smcv@debian.org>  Thu, 18 Feb 2021 13:49:58 +0000

gtk+3.0 (3.24.24-1) unstable; urgency=medium

  * New upstream release
    - Update the default color palette
    - Fix font chooser in family-only mode to return regular style
    - Don't set focus-on-click for tree view header buttons
    - Add a11y support to GtkPlug/GtkSocket
    - Implement scrollSubstringTo for a11y
    - Allow the lpr backend to print pdf and ps files
    - Update gesture graphics


=== debian/control ===
Source: gtk+3.0
Section: libs
Priority: optional
Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Simon McVittie <smcv@debian.org>, 
Build-Depends: adwaita-icon-theme <!nocheck>,
               at-spi2-core <!nocheck>,
               dbus <!nocheck>,
               debhelper-compat (= 12),
               dh-sequence-gir,
               fonts-cantarell <!nocheck>,
               fonts-dejavu-core <!nocheck>,
               gnome-pkg-tools (>= 0.11),
               gobject-introspection (>= 1.41.3),
               gsettings-desktop-schemas <!nocheck>,
               gtk-doc-tools (>= 1.20),
               libatk-bridge2.0-dev (>= 2.15.1),
               libatk1.0-dev (>= 2.35.1),
               libcairo2-dev (>= 1.14.0),
               libcolord-dev (>= 0.1.9),
               libcups2-dev (>= 1.7),
               libegl1-mesa-dev [linux-any],
               libepoxy-dev (>= 1.4),
               libfontconfig1-dev,
               libfribidi-dev (>= 0.19.7),
               libgdk-pixbuf-2.0-dev (>= 2.40.0) | libgdk-pixbuf2.0-dev (>= 2.40.0),
               libgirepository1.0-dev (>= 1.39.0),
               libglib2.0-dev (>= 2.57.2),
               libharfbuzz-dev (>= 0.9),
               libjson-glib-dev,
               libpango1.0-dev (>= 1.41.0),
               librest-dev,
               librsvg2-common <!nocheck>,
               libwayland-dev (>= 1.14.91) [linux-any],
               libx11-dev,
               libxcomposite-dev,
               libxcursor-dev,
               libxdamage-dev,
               libxext-dev,
               libxfixes-dev,
               libxi-dev,
               libxinerama-dev,
               libxkbcommon-dev (>= 0.2.0),
               libxkbfile-dev,
               libxml2-utils,
               libxrandr-dev (>= 2:1.5.0),
               pkg-config,
               sassc,
               wayland-protocols (>= 1.17) [linux-any],
               xauth <!nocheck>,
               xvfb <!nocheck>
Build-Depends-Indep: docbook-xml,
                     docbook-xsl,
                     libatk1.0-doc,
                     libcairo2-doc,
                     libglib2.0-doc,
                     libpango1.0-doc,
                     xsltproc
Rules-Requires-Root: no
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/gnome-team/gtk3
Vcs-Git: https://salsa.debian.org/gnome-team/gtk3.git -b debian/bullseye
Homepage: https://www.gtk.org/

Package: libgtk-3-0
Architecture: any
Multi-Arch: same
Depends: adwaita-icon-theme,
         hicolor-icon-theme,
         shared-mime-info,
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-3-common (>= ${source:Version})
Provides: gtk3-binver-3.0.0
Recommends: libgtk-3-bin,
            librsvg2-common
Suggests: gvfs,
Description: GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the shared libraries.

Package: libgtk-3-0-udeb
Build-Profiles: <!noudeb>
Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: gtk3-binver-3.0.0
Description: GTK graphical user interface library - minimal runtime
 This is a udeb, or a microdeb, for the debian-installer.
 .
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the minimal runtime library using X11 needed
 by the Debian installer.

Package: libgtk-3-common
Section: misc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: libgtk-3-0
Description: common files for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the common files which the libraries need.

Package: libgtk-3-bin
Section: misc
Architecture: any
Multi-Arch: foreign
Depends: gtk-update-icon-cache,
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-3-common (>= ${source:Version}),
         libgtk-3-0 (>= ${source:Version})
Breaks: gtk-3-examples (<< 3.24.13)
Replaces: gtk-3-examples (<< 3.24.13)
Description: programs for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the utilities which are used by the libraries
 and other packages.

Package: libgtk-3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: gir1.2-gtk-3.0 (= ${binary:Version}),
         libatk-bridge2.0-dev (>= 2.15.1),
         libatk1.0-dev (>= 2.35.1),
         libcairo2-dev (>= 1.14.0),
         libegl1-mesa-dev [linux-any],
         libepoxy-dev (>= 1.0),
         libfontconfig1-dev,
         libfribidi-dev (>= 0.19.7),
         libgdk-pixbuf-2.0-dev (>= 2.40.0) | libgdk-pixbuf2.0-dev (>= 2.40.0),
         libglib2.0-dev (>= 2.57.2),
         libpango1.0-dev (>= 1.41),
         libwayland-dev (>= 1.9.91) [linux-any],
         libx11-dev,
         libxcomposite-dev,
         libxcursor-dev,
         libxdamage-dev,
         libxext-dev,
         libxfixes-dev,
         libxi-dev,
         libxinerama-dev,
         libxkbcommon-dev,
         libxrandr-dev,
         pkg-config,
         wayland-protocols (>= 1.17) [linux-any],
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-3-common,
         libgtk-3-0 (= ${binary:Version})
Suggests: libgtk-3-doc
Description: development files for the GTK library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the header and development files which are
 needed for building GTK applications.

Package: libgtk-3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: libatk1.0-doc,
            libglib2.0-doc,
            libpango1.0-doc
Suggests: devhelp
Description: documentation for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the HTML documentation for the GTK library
 in /usr/share/doc/libgtk-3-doc/ .

Package: gtk-3-examples
Section: x11
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libgtk-3-0 (= ${binary:Version})
Description: example files for GTK 3
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the example files and a demonstration program
 for GTK3. It also contains the installed tests.

Package: gir1.2-gtk-3.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends: ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-3-common
Breaks: python-gi (<< 3.18),
        python3-gi (<< 3.18)
Provides: gir1.2-gdk-3.0 (= ${binary:Version}),
          gir1.2-gdkx11-3.0 (= ${binary:Version})
Description: GTK graphical user interface library -- gir bindings
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package can be used by other packages using the GIRepository format to
 generate dynamic bindings.

Package: gtk-update-icon-cache
Section: misc
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libgtk-3-bin (<< 3.20.6-1),
        libgtk2.0-bin (<< 2.24.30-2)
Replaces: libgtk-3-bin (<< 3.20.6-1),
          libgtk2.0-bin (<< 2.24.30-2)
Description: icon theme caching utility
 gtk-update-icon-cache creates mmap()able cache files for icon themes.
 .
 GTK can use the cache files created by gtk-update-icon-cache to avoid a lot
 of system call and disk seek overhead when the application starts. Since the
 format of the cache files allows them to be mmap()ed shared between multiple
 applications, the overall memory consumption is reduced as well.

Package: libgail-3-0
Architecture: any
Multi-Arch: same
Depends: at-spi2-core,
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-3-0 (= ${binary:Version})
Description: GNOME Accessibility Implementation Library -- shared libraries
 Gail implements ATK interfaces for GTK widgets which are dynamically
 loadable at runtime by a GTK application. Once loaded, those parts of
 an application that use standard GTK widgets will have a basic level
 of accessibility, without the need to modify the application at all.
 .
 This package contains the shared library.

Package: libgail-3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libatk1.0-dev,
         libgail-3-0 (= ${binary:Version}),
         pkg-config,
         ${misc:Depends},
         libgtk-3-dev (= ${binary:Version})
Suggests: libgail-3-doc
Description: GNOME Accessibility Implementation Library -- development files
 Gail implements ATK interfaces for GTK widgets which are dynamically
 loadable at runtime by a GTK application. Once loaded, those parts of
 an application that use standard GTK widgets will have a basic level
 of accessibility, without the need to modify the application at all.
 .
 This package contains the development files for Gail.

Package: libgail-3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: devhelp
Description: documentation files of the Gail library
 Gail implements ATK interfaces for GTK widgets which are dynamically
 loadable at runtime by a GTK application. Once loaded, those parts of
 an application that use standard GTK widgets will have a basic level
 of accessibility, without the need to modify the application at all.
 .
 This package contains the documentation files for Gail.

=== debian/rules ===
#!/usr/bin/make -f

DISABLE_UPDATE_UPLOADERS = 1
include /usr/share/gnome-pkg-tools/1/rules/uploaders.mk
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

built_binaries := $(shell dh_listpackages)
all_binaries := $(shell sed -ne 's/^Package: *//p' < debian/control)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# Ensure the build aborts when there are still references to undefined symbols
# currently fails at least in the im-multipress im module
#LDFLAGS += -Wl,-z,defs
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O1 -Wl,--as-needed

APIVER := 3
SONAME := 0

LIBDIR := usr/lib/$(DEB_HOST_MULTIARCH)

# earliest version that this release has backwards binary compatibility for
GTK_BINARY_VERSION := 3.0.0

# Gtk binary version virtual Provide
GTK_BINVER_DEP := gtk$(APIVER)-binver-$(GTK_BINARY_VERSION)

# relative base directory for configuration
CONFDIR := etc/gtk-3.0

# relative base directory for all types of modules
MODULES_BASE_PATH := $(LIBDIR)/gtk-3.0/$(GTK_BINARY_VERSION)
OLD_MODULES_BASE_PATH := usr/lib/gtk-3.0/$(GTK_BINARY_VERSION)

# package names
SHARED_PKG := libgtk-$(APIVER)-$(SONAME)
COMMON_PKG := libgtk-$(APIVER)-common
DEV_PKG := libgtk-$(APIVER)-dev
UDEB_PKG := $(SHARED_PKG)-udeb
DOC_PKG := libgtk-$(APIVER)-doc
BIN_PKG := libgtk-$(APIVER)-bin
EXAMPLES_PKG := gtk-$(APIVER)-examples

# files larger than 4k in size will be compressed by dh_compress
# so append a .gz suffix to avoid dangling symlinks
NEWS := NEWS$(shell find -maxdepth 1 -size +4k -name NEWS -exec echo ".gz" \;)
README := README$(shell find -maxdepth 1 -size +4k -name README -exec echo ".gz" \;)

# Avoid test failures on buildd environments
export HOME=$(CURDIR)/debian/build
export XDG_RUNTIME_DIR=$(HOME)
# So that gsettings can find the (uninstalled) gtk schemas
export XDG_DATA_DIRS=/usr/share:$(CURDIR)/debian/build
# Put these back to their defaults if we are not running with a clean
# environment, so that they are based on the temporary $HOME above
unexport XDG_CACHE_HOME
unexport XDG_CONFIG_DIRS
unexport XDG_CONFIG_HOME
unexport XDG_DATA_HOME
# Get failing tests' stdout/err so we have some information when a build fails
export VERBOSE=1

# macro computing the list of 'debian/<pkg>.*" files which have a
# corresponding ".in" file; pass the list of packages in $(1)
dh_subst_files = $(patsubst %.in,%,$(wildcard $(addprefix debian/, $(addsuffix *.in, $(1)))))

debian/%: debian/%.in
	dh_testdir
	sed \
		-e "s#@SONAME@#$(SONAME)#g" \
		-e "s#@APIVER@#$(APIVER)#g" \
		-e "s#@VERSION@#$(DEB_VERSION_UPSTREAM)#g" \
		-e "s#@GTK_BINVER_DEP@#$(GTK_BINVER_DEP)#g" \
		-e "s#@SHARED_PKG@#$(SHARED_PKG)#g" \
		-e "s#@COMMON_PKG@#$(COMMON_PKG)#g" \
		-e "s#@DEV_PKG@#$(DEV_PKG)#g" \
		-e "s#@UDEB_PKG@#$(UDEB_PKG)#g" \
		-e "s#@DOC_PKG@#$(DOC_PKG)#g" \
		-e "s#@BIN_PKG@#$(BIN_PKG)#g" \
		-e "s#@EXAMPLES_PKG@#$(EXAMPLES_PKG)#g" \
		-e "s#@GNOME_TEAM@#$(UPLOADERS)#g" \
		-e "s#@GTK_BINARY_VERSION@#$(GTK_BINARY_VERSION)#g" \
		-e "s#@LIBDIR@#$(LIBDIR)#g" \
		-e 's#@CONFDIR@#$(CONFDIR)#g' \
		-e "s#@MODULES_BASE_PATH@#$(MODULES_BASE_PATH)#g" \
		-e "s#@OLD_MODULES_BASE_PATH@#$(OLD_MODULES_BASE_PATH)#g" \
		-e "s#@NEWS@#$(NEWS)#g" \
		-e "s#@README@#$(README)#g" \
		$@.in > $@

configure_flags_common = \
	--libdir=/$(LIBDIR) \
	--enable-test-print-backend

configure_flags_deb = \
	--enable-broadway-backend \
	--enable-x11-backend \
	--enable-gtk-doc \
	--enable-man \
	--enable-shared \
	--enable-introspection \
	--enable-cloudprint \
	--disable-static \
	--enable-installed-tests

ifeq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
configure_flags_deb += --enable-colord
else
configure_flags_deb += --disable-colord
endif

ifeq (linux,$(DEB_HOST_ARCH_OS))
configure_flags_deb += --enable-wayland-backend
else
configure_flags_deb += --disable-wayland-backend
endif

ifeq ($(filter %-doc,$(built_binaries)),)
configure_flags_deb += --disable-gtk-doc --disable-man
endif

configure_flags_udeb = \
	--disable-broadway-backend \
	--disable-wayland-backend \
	--enable-x11-backend \
	--disable-introspection \
	--disable-cloudprint \
	--disable-colord \
	--disable-xcomposite \
	--disable-xdamage \
	--disable-xfixes \
	--disable-xrandr

%:
	dh $@ --buildsystem=autoconf

override_dh_clean: debian/control
	# gross kludge to force control generation with the %.in target
	touch debian/control.in
	rm -f $(call dh_subst_files,$(all_binaries))
	rm -f testsuite/reftests/*.ui.known_fail
	rm -rf debian/build debian/install
	# The build system does not automatically update the GResource files
	# when resources change. Force an update in case we ship a patch which
	# modifies the theme CSS files.
	rm -f gtk/gtkresources.c gtk/gtkresources.h
	rm -f gtk/theme/Adwaita/gtk-contained.css
	rm -f gtk/theme/Adwaita/gtk-contained-dark.css
	rm -f gtk/theme/HighContrast/gtk-contained.css
	rm -f gtk/theme/HighContrast/gtk-contained-inverse.css
	# We just don't want to have to review these...
	rm -f demos/gtk-demo/demo_resources.[ch]
	rm -f demos/icon-browser/resources.[ch]
	rm -f demos/widget-factory/widget_factory_resources.[ch]
	rm -f docs/reference/gtk/getting_started.xml
	rm -f examples/application*/resources.[ch]
	rm -f gdk/gdkenumtypes.[ch]
	rm -f gdk/gdkmarshalers.[ch]
	rm -f gdk/gdkresources.[ch]
	rm -f gtk/gtkmarshalers.[ch]
	rm -f gtk/gtkprivatetypebuiltins.[ch]
	rm -f gtk/gtkresources.[ch]
	rm -f gtk/gtktypebuiltins.[ch]
	rm -f testsuite/css/style/resources.[ch]
	rm -f testsuite/gtk/gtkresources.[ch]
	dh_clean

# Add dependencies to generate files from the debian/*.in ones
override_dh_auto_build: $(call dh_subst_files,$(all_binaries))

override_dh_autoreconf:
	NOCONFIGURE=true dh_autoreconf ./autogen.sh

override_dh_auto_configure: debian/control
	dh_auto_configure \
		--builddirectory=debian/build/deb \
		-- \
		$(configure_flags_common) \
		$(configure_flags_deb) \
		$(NULL)
ifneq ($(filter %-udeb,$(built_binaries)),)
	dh_auto_configure \
		--builddirectory=debian/build/udeb \
		-- \
		$(configure_flags_common) \
		$(configure_flags_udeb) \
		$(NULL)
endif

override_dh_auto_build:
	( cd gtk/theme/Adwaita; ./parse-sass.sh )
	( cd gtk/theme/HighContrast; ./parse-sass.sh )
	dh_auto_build --builddirectory=debian/build/deb
ifneq ($(filter %-udeb,$(built_binaries)),)
	dh_auto_build --builddirectory=debian/build/udeb
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Mark reftests with known failures as non-fatal
	# (See also somehow_broken in testsuite/reftests/meson.build)
	touch testsuite/reftests/button-wrapping.ui.known_fail
	touch testsuite/reftests/cellrenderer-pixbuf-stock-rtl.ui.known_fail
	touch testsuite/reftests/flipping-icons.ui.known_fail
	touch testsuite/reftests/label-sizing.ui.known_fail
	touch testsuite/reftests/label-wrap-justify.ui.known_fail
	touch testsuite/reftests/quit-mnemonic.ui.known_fail
	touch testsuite/reftests/symbolic-icon-translucent-color.ui.known_fail
	touch testsuite/reftests/window-height-for-width.ui.known_fail
	# So that gsettings can find the (uninstalled) gtk schemas
	mkdir -p debian/build/glib-2.0/schemas/
	cp gtk/org.gtk.* debian/build/glib-2.0/schemas/
	glib-compile-schemas debian/build/glib-2.0/schemas/
	# Remove LD_PRELOAD so we don't run with fakeroot, which makes dbus-related tests fail
	env -u LD_PRELOAD xvfb-run -a dh_auto_test --builddirectory=debian/build/deb -- -k check -j1
endif

override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build/deb --destdir=debian/install/deb
	rm -v -f debian/install/deb/usr/libexec/installed-tests/gtk+/reftests/libreftest.la
ifneq ($(filter %-udeb,$(built_binaries)),)
	dh_auto_install --builddirectory=debian/build/udeb --destdir=debian/install/udeb
endif

override_dh_install:
	dh_install -p$(UDEB_PKG) --sourcedir=debian/install/udeb
	dh_install --remaining-packages --sourcedir=debian/install/deb

override_dh_missing:
ifneq ($(filter %-udeb,$(built_binaries)),)
	dh_missing --sourcedir=debian/install/udeb --list-missing -X.la
endif
	dh_missing --sourcedir=debian/install/deb --list-missing -X.la

=== debian/tests/control ===
Tests: build python3-gi
Depends: libgtk-3-dev, build-essential, xauth, xvfb, python3-gi, gir1.2-gtk-3.0, dbus
Restrictions: allow-stderr, superficial

Tests: installed-tests
Depends: at-spi2-core, dbus (>= 1.8), gnome-desktop-testing (>= 2018.1-1~), gtk-3-examples, librsvg2-common, xauth, xvfb
Restrictions: allow-stderr

Tests: installed-tests-a11ystate installed-tests-reftests
Depends: at-spi2-core, dbus (>= 1.8), gnome-desktop-testing (>= 2018.1-1~), gtk-3-examples, librsvg2-common, xauth, xvfb
Restrictions: allow-stderr, flaky

## gtk+3.0 3.24.25

=== debian/changelog ===
gtk+3.0 (3.24.25-1ubuntu4.1) hirsute; urgency=medium

  * debian/patches/git_imcontext.patch:
    - cherry pick imcontext fixes until 3.24.29 (LP: #1925379)

 -- Rico Tzschichholz <ricotz@ubuntu.com>  Sat, 01 May 2021 10:01:31 +0200

gtk+3.0 (3.24.25-1ubuntu4) hirsute; urgency=medium

  * debian/patches/git_wayland_fonts.patch:
    - cherry pick a fix for GTK applications hitting errors under wayland
      on GNOME40, it isn't in Ubuntu yet but it should make testing the
      new version easier and also updates packages are provided in ppa
      already for testing so it should avoid surprises for those users
      (lp: #1922464)

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 08 Apr 2021 11:17:35 +0200

gtk+3.0 (3.24.25-1ubuntu3) hirsute; urgency=medium

  * d/p/x11-dnd-Ignore-XErrors-from-the-COW.patch:
    - Ignore XErrors from the COW (LP: #1911036)
  * d/p/cssshadowvalue-Apply-device-scale-to-the-offset-when.patch:
    - Apply device scale to the offset when blurring text
      (LP: #1919404)

 -- Daniel van Vugt <daniel.van.vugt@canonical.com>  Thu, 25 Mar 2021 16:17:15 +0100

gtk+3.0 (3.24.25-1ubuntu2) hirsute; urgency=medium

  * No-change rebuild to drop the udeb package.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2021 10:33:53 +0100

gtk+3.0 (3.24.25-1ubuntu1) hirsute; urgency=medium

  * Merge with Debian. Remaining changes:
    + Install a settings.ini file to set our themes
    + Update debian/libgtk-3-0.symbols
    + debian/control.in and debian/tests/control (installed-tests):
      - Build-depend on adwaita-icon-theme-full for icon name check test
    + debian/control.in: Build-Depend on dh-sequence-translations
    + Ubuntu-specific patches:
      - 073_treeview_almost_fixed.patch
      - bzg_gtkcellrenderer_grabbing_modifier.patch
      - ubuntu_gtk_custom_menu_items.patch
      - print-dialog-show-options-of-remote-dnssd-printers.patch
      - uimanager-guard-against-nested-node-updates.patch
      - x-canonical-accel.patch
      - message-dialog-restore-traditional-look-on-unity.patch
      - 0001-gtk-reftest-Force-icon-theme-to-Adwaita.patch
      - restore_filechooser_typeaheadfind.patch
      - 0001-calendar-always-emit-day-selected-once.patch
      - 0001-gtkwindow-set-transparent-background-color.patch
      - unity-border-radius.patch
      - unity-headerbar-maximized-mode.patch

 -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 19 Feb 2021 11:35:15 +0100

gtk+3.0 (3.24.25-1) experimental; urgency=medium

  * New upstream release
    - Support for cursor aspect ratio setting
    - Broadway fixes
    - Avoid crashes with tablet input in Wayland
    - Add API for better support for Wayland subsurfaces
    - Make the Inspector available in non-debug builds
    - Make scrollbars larger
    - Disable shadows on maximized, fullscreen and tiled windows
    - Support Avahi-discovered printers better
    - Show preedit for compose sequences
    - Support long compose sequences
    - Support compose sequences producing multiple characters
    - Translation updates
  * Upload to experimental for now, to assess whether this is desirable
    for bullseye

 -- Simon McVittie <smcv@debian.org>  Thu, 18 Feb 2021 16:34:08 +0000

gtk+3.0 (3.24.24-1ubuntu1) hirsute; urgency=medium

  * Merge with Debian. Remaining changes:
    + Install a settings.ini file to set our themes
    + Update debian/libgtk-3-0.symbols
    + debian/control.in and debian/tests/control (installed-tests):
      - Build-depend on adwaita-icon-theme-full for icon name check test
    + debian/control.in: Build-Depend on dh-sequence-translations
    + Ubuntu-specific patches:
      - 073_treeview_almost_fixed.patch
      - bzg_gtkcellrenderer_grabbing_modifier.patch
      - ubuntu_gtk_custom_menu_items.patch
      - print-dialog-show-options-of-remote-dnssd-printers.patch
      - uimanager-guard-against-nested-node-updates.patch
      - x-canonical-accel.patch
      - message-dialog-restore-traditional-look-on-unity.patch
      - 0001-gtk-reftest-Force-icon-theme-to-Adwaita.patch
      - restore_filechooser_typeaheadfind.patch
      - 0001-calendar-always-emit-day-selected-once.patch
      - 0001-gtkwindow-set-transparent-background-color.patch
      - unity-border-radius.patch
      - unity-headerbar-maximized-mode.patch

 -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 25 Jan 2021 12:38:37 +0100

gtk+3.0 (3.24.23-1ubuntu2) hirsute; urgency=medium

  * debian/patches/fontchooser_Fix_family-only_mode.patch:
    - Show regular monospace fonts in gnome-terminal's profile editor
      and not arbitrary font styles (LP: #1900729)

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Mon, 02 Nov 2020 10:45:57 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: gtk+3.0
 Section: libs
 Priority: optional
-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
-Uploaders: Simon McVittie <smcv@debian.org>, 
-Build-Depends: adwaita-icon-theme <!nocheck>,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
+Uploaders: Simon McVittie <smcv@debian.org>, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
+Build-Depends: adwaita-icon-theme-full <!nocheck>,
                at-spi2-core <!nocheck>,
                dbus <!nocheck>,
                debhelper-compat (= 12),
                dh-sequence-gir,
+               dh-sequence-translations,
                fonts-cantarell <!nocheck>,
                fonts-dejavu-core <!nocheck>,
                gnome-pkg-tools (>= 0.11),
@@ -58,8 +60,10 @@
                      xsltproc
 Rules-Requires-Root: no
 Standards-Version: 4.5.1
-Vcs-Browser: https://salsa.debian.org/gnome-team/gtk3
-Vcs-Git: https://salsa.debian.org/gnome-team/gtk3.git -b debian/bullseye
+XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gtk3.git
+XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gtk3
+Vcs-Git: https://salsa.debian.org/gnome-team/gtk3.git -b ubuntu/master
+Vcs-Browser: https://salsa.debian.org/gnome-team/gtk3/tree/ubuntu/master
 Homepage: https://www.gtk.org/
 
 Package: libgtk-3-0

=== debian/rules ===
--- 
+++ 
@@ -199,13 +199,16 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Mark reftests with known failures as non-fatal
 	# (See also somehow_broken in testsuite/reftests/meson.build)
+	touch testsuite/reftests/box-shadow-changes-modify-clip.ui.known_fail
 	touch testsuite/reftests/button-wrapping.ui.known_fail
 	touch testsuite/reftests/cellrenderer-pixbuf-stock-rtl.ui.known_fail
 	touch testsuite/reftests/flipping-icons.ui.known_fail
 	touch testsuite/reftests/label-sizing.ui.known_fail
+	touch testsuite/reftests/label-text-shadow-changes-modify-clip.ui.known_fail
 	touch testsuite/reftests/label-wrap-justify.ui.known_fail
 	touch testsuite/reftests/quit-mnemonic.ui.known_fail
 	touch testsuite/reftests/symbolic-icon-translucent-color.ui.known_fail
+	touch testsuite/reftests/text-shadow-changes-modify-clip.ui.known_fail
 	touch testsuite/reftests/window-height-for-width.ui.known_fail
 	# So that gsettings can find the (uninstalled) gtk schemas
 	mkdir -p debian/build/glib-2.0/schemas/
@@ -223,12 +226,5 @@
 endif
 
 override_dh_install:
-	dh_install -p$(UDEB_PKG) --sourcedir=debian/install/udeb
-	dh_install --remaining-packages --sourcedir=debian/install/deb
-
-override_dh_missing:
-ifneq ($(filter %-udeb,$(built_binaries)),)
-	dh_missing --sourcedir=debian/install/udeb --list-missing -X.la
-endif
-	dh_missing --sourcedir=debian/install/deb --list-missing -X.la
-
+	# Install custom settings
+	mkdir -p debian/$(SHARED_PKG)/$(CONFDIR)

## gtk+3.0 3.24.27

=== debian/changelog ===
gtk+3.0 (3.24.27-1pureos2~amber0) amber-phone; urgency=medium

  * Make GtkShortcutsWindow adaptive

 -- Alexander Mikhaylenko <alexander.mikhaylenko@puri.sm>  Mon, 22 Mar 2021 13:29:44 +0500

gtk+3.0 (3.24.27-1pureos1~amber0) amber-phone; urgency=medium

  [ Alexander Mikhaylenko ]
  * New upstream release

 -- Alexander Mikhaylenko <alexander.mikhaylenko@puri.sm>  Thu, 18 Mar 2021 12:43:28 +0500

gtk+3.0 (3.24.24-1pureos1~amber0) amber-phone; urgency=medium

  * Backport fixes from libhandy
  * Stop including HdyStackableBox and HdyLeaflet
  * Include HdyAnimation and HdyFlap
  * Replace HdyLeaflet with HdyFlap in the file chooser
  * Make the second line of text in file chooser rows half-transparent
  * Hide file chooser image preview on mobile
  * Make GtkMessageDialog and GtkHeaderBar follow is-phone changes on the fly
  * Revert GtkInfoBar changes when is-phone is false, change it on the fly
  * Adapt print dialog for phones

 -- Alexander Mikhaylenko <alexander.mikhaylenko@puri.sm>  Tue, 16 Feb 2021 12:06:03 +0500

gtk+3.0 (3.24.24-1pureos0~amber0) amber-phone; urgency=medium

  [ purism ]
  * New upstream release

  [ Alexander Mikhaylenko ]
  * Update patches
  * Revert the changes requiring newer libatk

 -- Alexander Mikhaylenko <alexander.mikhaylenko@puri.sm>  Fri, 11 Dec 2020 16:31:06 +0500

gtk+3.0 (3.24.24~really3.23.23-1pureos0) amber-phone; urgency=high

  [ Danct12 ]
  * Add org.gtk.Settings.Purism to gtk/Makefile.am

  [ Alexander Mikhaylenko ]
  * events: Compress touch update events
  * Fix message dialog style

  [ Arnaud Ferraris ]
  * debian: libgtk-3-common: install Purism gschema

 -- Alexander Mikhaylenko <alexander.mikhaylenko@puri.sm>  Mon, 07 Dec 2020 16:45:03 +0500

gtk+3.0 (3.24.23-2pureos3) amber-phone; urgency=high

  * Disable window dragging on phones

 -- Alexander Mikhaylenko <alexander.mikhaylenko@puri.sm>  Tue, 10 Nov 2020 12:39:57 +0500

gtk+3.0 (3.24.23-2pureos2) amber-phone; urgency=medium

  * Fix the build

 -- Alexander Mikhaylenko <alexander.mikhaylenko@puri.sm>  Wed, 04 Nov 2020 19:10:43 +0500

gtk+3.0 (3.24.23-2pureos1) amber-phone; urgency=medium

  [ Adrien Plazas ]
  * librem5: Add CI

  [ Alexander Mikhaylenko ]
  * Adjust gbp config for amber-phone
  * Revert "Build-depend on gdk-pixbuf 2.40 instead of working around an old bug"
  * Add previous downstream patches

 -- Alexander Mikhaylenko <alexander.mikhaylenko@puri.sm>  Tue, 03 Nov 2020 17:02:07 +0500

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,21 @@
 Source: gtk+3.0
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
-Uploaders: Simon McVittie <smcv@debian.org>, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
-Build-Depends: adwaita-icon-theme-full <!nocheck>,
+Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
+Uploaders: Iain Lane <laney@debian.org>
+Build-Depends: adwaita-icon-theme <!nocheck>,
                at-spi2-core <!nocheck>,
                dbus <!nocheck>,
                debhelper-compat (= 12),
                dh-sequence-gir,
-               dh-sequence-translations,
                fonts-cantarell <!nocheck>,
                fonts-dejavu-core <!nocheck>,
                gnome-pkg-tools (>= 0.11),
                gobject-introspection (>= 1.41.3),
                gsettings-desktop-schemas <!nocheck>,
                gtk-doc-tools (>= 1.20),
-               libatk-bridge2.0-dev (>= 2.15.1),
-               libatk1.0-dev (>= 2.35.1),
+               libatk-bridge2.0-dev,
+               libatk1.0-dev (>= 2.15.1),
                libcairo2-dev (>= 1.14.0),
                libcolord-dev (>= 0.1.9),
                libcups2-dev (>= 1.7),
@@ -25,7 +23,7 @@
                libepoxy-dev (>= 1.4),
                libfontconfig1-dev,
                libfribidi-dev (>= 0.19.7),
-               libgdk-pixbuf-2.0-dev (>= 2.40.0) | libgdk-pixbuf2.0-dev (>= 2.40.0),
+               libgdk-pixbuf2.0-dev (>= 2.30.0),
                libgirepository1.0-dev (>= 1.39.0),
                libglib2.0-dev (>= 2.57.2),
                libharfbuzz-dev (>= 0.9),
@@ -48,7 +46,7 @@
                libxrandr-dev (>= 2:1.5.0),
                pkg-config,
                sassc,
-               wayland-protocols (>= 1.17) [linux-any],
+               wayland-protocols (>= 1.14) [linux-any],
                xauth <!nocheck>,
                xvfb <!nocheck>
 Build-Depends-Indep: docbook-xml,
@@ -59,11 +57,9 @@
                      libpango1.0-doc,
                      xsltproc
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
-XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gtk3.git
-XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gtk3
-Vcs-Git: https://salsa.debian.org/gnome-team/gtk3.git -b ubuntu/master
-Vcs-Browser: https://salsa.debian.org/gnome-team/gtk3/tree/ubuntu/master
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/gnome-team/gtk3
+Vcs-Git: https://salsa.debian.org/gnome-team/gtk3.git
 Homepage: https://www.gtk.org/
 
 Package: libgtk-3-0
@@ -76,9 +72,9 @@
          ${shlibs:Depends},
          libgtk-3-common (>= ${source:Version})
 Provides: gtk3-binver-3.0.0
-Recommends: libgtk-3-bin,
-            librsvg2-common
+Recommends: libgtk-3-bin
 Suggests: gvfs,
+          librsvg2-common
 Description: GTK graphical user interface library
  GTK is a multi-platform toolkit for creating graphical user
  interfaces. Offering a complete set of widgets, GTK is suitable
@@ -145,14 +141,14 @@
 Architecture: any
 Multi-Arch: same
 Depends: gir1.2-gtk-3.0 (= ${binary:Version}),
-         libatk-bridge2.0-dev (>= 2.15.1),
-         libatk1.0-dev (>= 2.35.1),
+         libatk-bridge2.0-dev,
+         libatk1.0-dev (>= 2.15.1),
          libcairo2-dev (>= 1.14.0),
          libegl1-mesa-dev [linux-any],
          libepoxy-dev (>= 1.0),
          libfontconfig1-dev,
          libfribidi-dev (>= 0.19.7),
-         libgdk-pixbuf-2.0-dev (>= 2.40.0) | libgdk-pixbuf2.0-dev (>= 2.40.0),
+         libgdk-pixbuf2.0-dev (>= 2.30.0),
          libglib2.0-dev (>= 2.57.2),
          libpango1.0-dev (>= 1.41),
          libwayland-dev (>= 1.9.91) [linux-any],
@@ -167,7 +163,7 @@
          libxkbcommon-dev,
          libxrandr-dev,
          pkg-config,
-         wayland-protocols (>= 1.17) [linux-any],
+         wayland-protocols (>= 1.14) [linux-any],
          ${misc:Depends},
          ${shlibs:Depends},
          libgtk-3-common,
